module DockerRailsProxy
  class Rails < SyncBack
    class Credentials < self
      attr_accessor :options

      after_initialize { self.options = {} }
      after_initialize { opt_parser.parse!(arguments) }

      validates { '--environment is required' if options[:environment].nil? }

      def process
        command = "EDITOR=vim bin/rails credentials:edit --environment #{options[:environment]}"
        execute "bash -c '#{command}'", tty: true
      end

      private

      def opt_parser
        @opt_parser ||= OptionParser.new do |opts|
          opts.banner = "Usage: bin/#{APP_NAME} rails credentials [options]"

          opts.on(
            '--environment ENVIRONMENT', 'App environment'
          ) { |environment| options[:environment] = environment }

          opts.on('-h', '--help', 'Display this screen') do
            puts opts
            exit
          end
        end
      end
    end
  end
end
