require 'logger'

module DockerRailsProxy
  def self.logger
    @logger ||= ::Logger.new(STDOUT).tap do |log|
      log.formatter = proc do |severity, datetime, progname, msg|
        "#{severity[0]}, [#{datetime.strftime('%Y-%m-%d %T')}] -- : #{msg}\n"
      end
    end
  end

  def self.log_level(level: nil)
    logger.level = level || ::Logger::INFO
  end

  module Logger
    class << self
      def included(base)
        base.extend(ClassMethods)
      end
    end

    module ClassMethods
      def logger
        ::DockerRailsProxy.logger
      end
    end

    def logger
      ::DockerRailsProxy.logger
    end
  end
end
